
function [z_cut,w,p,m,mu_inter] = solve_Hopenhayn(beta,alpha,ce,cf,D,N,nz,z,g,prob,wgridMin,wgridMax)

nw = 101;

wincast = (wgridMax - wgridMin)/(nw - 1);
wgrid = (wgridMin:wincast:wgridMax).';
wgrid_cell = num2cell(wgrid);
[~,~,~,~,~,~,~,~,check_n] = cellfun(@(x) VFI_given_n(x,nz,z,prob,g,alpha,cf,ce,beta,D,N), wgrid_cell, "UniformOutput", false);
check_n = cell2mat(check_n);
% assert(sum(check_n>0)<nw && sum(check_n<0)<nw,'The value of w is either too large or too small!');

% check_n = ones(nw);
% while sum(check_n>0)==nw || sum(check_n<0)==nw
%     wincast = (wgridMax - wgridMin)/(nw - 1);
%     wgrid = (wgridMin:wincast:wgridMax).';
%     wgrid_cell = num2cell(wgrid);
%     [~,~,~,~,~,~,~,~,check_n] = cellfun(@(x) VFI_given_n(x,nz,z,prob,g,alpha,cf,ce,beta,D,N), wgrid_cell, "UniformOutput", false);
%     check_n = cell2mat(check_n);
%     if sum(check_n>0)==nw
%         wgridMin = wgridMin-0.1;
%         wgridMax = wgridMax-0.1;
%     elseif sum(check_n<0)==nw
%         wgridMin = wgridMin+0.1;
%         wgridMax = wgridMax+0.1;
%     end
% end

% w = interp1(check_n,wgrid,0);
% w = interp1(check_n,wgrid,0,'linear','extrap');
w = interp1(check_n,wgrid,0,'spline','extrap');

% wgridMin = w-1e-7;
% wgridMax = w+1e-7;
% wincast = (wgridMax - wgridMin)/(nw - 1);
% wgrid = (wgridMin:wincast:wgridMax).';
% wgrid_cell = num2cell(wgrid);
% [~,~,~,~,~,~,~,check_n] = cellfun(@(x) VFI_given_n(x,nz,z,prob,g,alpha,cf,ce,beta,D,N), wgrid_cell, "UniformOutput", false);
% check_n = cell2mat(check_n);
% if sum(check_n==0)>0
%     w = wgrid(find(check_n==0,1));
% else
%     w = interp1(check_n,wgrid,0,'spline','extrap');
% end

[~,~,mu_inter,p,m,z_cut,~,~,~] = VFI_given_n(w,nz,z,prob,g,alpha,cf,ce,beta,D,N);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Local Functions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [v_new,mu_new,mu_inter,p,m,z_cut,check_p0,check_mu0,check_n] = VFI_given_n(w,nz,z,prob,g,alpha,cf,ce,beta,D,N)

    pgridMin = w;                       
    pgridMax = 2*w;                      
    np = 101;                        
    pincast = (pgridMax - pgridMin)/(np - 1); 
    pgrid = (pgridMin:pincast:pgridMax).';   

%     maxiter_v = 5000;                
%     tol_v = 1e-5;                     

    % v_new = zeros(np,nz);
    % contemporary profit
    pi_vec = (1-alpha)/alpha*(w^alpha/alpha./(pgrid*z')).^(1/(alpha-1))-cf;  

    % value function iteration
%     for niter_v = 1:maxiter_v
%         v_old = v_new;
%         v_new = pi_vec + beta*max(0,v_old*prob);
%         if max(abs(v_new-v_old)) < tol_v
%             break;
%         elseif niter_v == maxiter_v
%             fprintf("Fail to Converge for v!\n");
%         end
%     end

     % Ax = b ——》x = A\b;
     % xA = b ——》x = b/A;
     v_new = pi_vec/(eye(nz)-beta*prob);
     v_new(v_new*prob<0) = pi_vec(v_new*prob<0);

    % check free entry condition and calculate cutoff productivity
    check_p = v_new*g - ce;
    % idx = find(check_p>0,1);
    % p = pgrid(idx) + (-check_p(idx))/(check_p(idx+1)-check_p(idx))*(pgrid(idx+1)-pgrid(idx));
    % p = interp1(check_p(idx:idx+1),pgrid(idx:idx+1),0,'spline','extrap');
    % p = interp1(check_p,pgrid,0,'linear','extrap');
    p = interp1(check_p,pgrid,0,'spline','extrap');
    v_new_cell = mat2cell(v_new,[np],ones(1,nz));
    v_inter = cell2mat(cellfun(@(x) interp1(pgrid,x,p,'spline','extrap'),v_new_cell,'UniformOutput',false));
    check_z = prob*v_inter';
    % z_cut = interp1(check_z,z,0,'spline','extrap');
    z_cut = z(find(check_z>0,1)-1);
    check_p0 = v_inter*g - ce;                   

    nm = 101;
    mMin = 0.01;
    mMax = 0.99;
    mincast = (mMax - mMin)/(nm - 1); 
    mgrid = (mMin:mincast:mMax).';    
    
    % stationary distribution
    mu_new = mgrid*g'/(eye(nz)-prob.*(ones(nz,1)*(z>z_cut)'));
    
    % check goods market clearing
    q = z.^(1/(1-alpha))*(w/p/alpha)^(alpha/(alpha-1));
    check_mu = mu_new*q - D;
    % idx = find(check_mu>0,1);
    % m = mgrid(idx) + (-check_mu(idx))/(check_mu(idx+1)-check_mu(idx))*(mgrid(idx+1)-mgrid(idx));
    % m = interp1(check_mu(idx:idx+1),mgrid(idx:idx+1),0,'spline','extrap');
    % m = interp1(check_mu,mgrid,0,'linear','extrap');
    m = interp1(check_mu,mgrid,0,'spline','extrap');
    % mu_inter = interp2(mgrid,z,mu_new,m,z);
    mu_new_cell = mat2cell(mu_new,[nm],ones(1,nz));
    mu_inter = cell2mat(cellfun(@(x) interp1(mgrid,x,m,'spline','extrap'),mu_new_cell,'UniformOutput',false));
    check_mu0 = mu_inter*q - D;
    
    % check labor market clearing
    n_vec = (w/p/alpha./z).^(1/(alpha-1));
    check_n = mu_inter*n_vec - N;
end

end

